﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 6; i++)
            {
                dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            #endregion

            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("CategoryName");
            this.gridGroupingControl1.Table.ExpandAllGroups();
        }

        private void moveBtn_Click(object sender, EventArgs e)
        {
            //Set your needed column index
            int colIndex = this.gridGroupingControl1.TableDescriptor.FieldToColIndex(0);

            //Getting the record rowIndex based on its position
            int rowIndex = this.gridGroupingControl1.Table.Records[0].GetRowIndex();

            //Moving the current cell
            this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(rowIndex, colIndex, Syncfusion.Windows.Forms.Grid.GridSetCurrentCellOptions.SetFocus);           
            this.gridGroupingControl1.Focus();

            //Setting the cursor at end position of cell
            if (this.gridGroupingControl1.TableControl.CurrentCell.Renderer is GridTextBoxCellRenderer)
            {
                GridTextBoxCellRenderer renderer = this.gridGroupingControl1.TableControl.CurrentCell.Renderer as GridTextBoxCellRenderer;
                renderer.TextBox.SelectionStart = renderer.TextBox.Text.Length;
            }
        }

        private void moveWithHighlightBtn_Click(object sender, EventArgs e)
        {
            //Set your needed column index
            int colIndex = this.gridGroupingControl1.TableDescriptor.FieldToColIndex(0);

            //Getting the record rowIndex based on its position
            int rowIndex = this.gridGroupingControl1.Table.Records[0].GetRowIndex();

            //Moving the current cell
            this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(rowIndex, colIndex, Syncfusion.Windows.Forms.Grid.GridSetCurrentCellOptions.SetFocus);
            this.gridGroupingControl1.Focus();

            //Highlighting the cellvalue
            if (this.gridGroupingControl1.TableControl.CurrentCell.Renderer is GridTextBoxCellRenderer)
            {
                GridTextBoxCellRenderer renderer = this.gridGroupingControl1.TableControl.CurrentCell.Renderer as GridTextBoxCellRenderer;
                renderer.TextBox.SelectAll();
            }
        }        
    }
}
